
// AriesStepViewCtl.cpp: Implementierung der CAriesStepViewCtrl-ActiveX-Steuerelementklasse.

#include "stdafx.h"
#include "AriesStepView.h"
#include "AriesStepViewCtl.h"
#include "AriesStepViewPpg.h"
#include <assert.h>
#include <comdef.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CAriesStepViewCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Nachrichtenzuordnungstabelle

BEGIN_MESSAGE_MAP(CAriesStepViewCtrl, COleControl)
	//{{AFX_MSG_MAP(CAriesStepViewCtrl)
	// HINWEIS - Der Klassen-Assistent fgt Nachrichtenzuordnungseintrge hinzu und entfernt diese
	//    Innerhalb dieser generierten Quelltextabschnitte NICHTS VERNDERN!
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch-Tabelle

BEGIN_DISPATCH_MAP(CAriesStepViewCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CAriesStepViewCtrl)
	DISP_PROPERTY_EX(CAriesStepViewCtrl, "Position", GetPosition, SetPosition, VT_I2)
	DISP_PROPERTY_EX(CAriesStepViewCtrl, "stepWidth", GetStepWidth, SetStepWidth, VT_I2)
	DISP_PROPERTY_EX(CAriesStepViewCtrl, "StepNum", GetStepNum, SetStepNum, VT_I2)
	DISP_FUNCTION(CAriesStepViewCtrl, "clearAll", clearAll, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CAriesStepViewCtrl, "addStep", addStep, VT_EMPTY, VTS_BSTR)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Ereignistabelle

BEGIN_EVENT_MAP(CAriesStepViewCtrl, COleControl)
	//{{AFX_EVENT_MAP(CAriesStepViewCtrl)
	// HINWEIS - Der Klassen-Assistent fgt Eintrge in die Ereignistabelle ein und entfernt diese
	//    Innerhalb dieser generierten Quelltextabschnitte NICHTS VERNDERN!
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Eigenschaftenseiten

// ZU ERLEDIGEN: Fgen Sie mehr Eigenschaftenseiten ein, als erforderlich sind.  Denken Sie daran, den Zhler zu erhhen!
BEGIN_PROPPAGEIDS(CAriesStepViewCtrl, 1)
	PROPPAGEID(CAriesStepViewPropPage::guid)
END_PROPPAGEIDS(CAriesStepViewCtrl)


/////////////////////////////////////////////////////////////////////////////
// Klassenerzeugung und GUID initialisieren

IMPLEMENT_OLECREATE_EX(CAriesStepViewCtrl, "ARIESSTEPVIEW.AriesStepViewCtrl.1",
	0xff70d8ee, 0x1d86, 0x11d3, 0x9c, 0xa3, 0xd2, 0xd3, 0xc4, 0, 0, 0)


/////////////////////////////////////////////////////////////////////////////
// Typbibliothek-ID und Version

IMPLEMENT_OLETYPELIB(CAriesStepViewCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Schnittstellen-IDs

const IID BASED_CODE IID_DAriesStepView =
		{ 0xff70d8ec, 0x1d86, 0x11d3, { 0x9c, 0xa3, 0xd2, 0xd3, 0xc4, 0, 0, 0 } };
const IID BASED_CODE IID_DAriesStepViewEvents =
		{ 0xff70d8ed, 0x1d86, 0x11d3, { 0x9c, 0xa3, 0xd2, 0xd3, 0xc4, 0, 0, 0 } };


/////////////////////////////////////////////////////////////////////////////
// Steuerelement-Typinformation

static const DWORD BASED_CODE _dwAriesStepViewOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CAriesStepViewCtrl, IDS_ARIESSTEPVIEW, _dwAriesStepViewOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CAriesStepViewCtrl::CAriesStepViewCtrlFactory::UpdateRegistry -
// Fgt Eintrge der Systemregistrierung fr CAriesStepViewCtrl hinzu oder entfernt diese

BOOL CAriesStepViewCtrl::CAriesStepViewCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// ZU ERLEDIGEN: Prfen Sie, ob Ihr Steuerelement den Thread-Regeln nach dem "Apartment"-Modell entspricht.
	// Weitere Informationen finden Sie unter MFC TechNote 64.
	// Falls Ihr Steuerelement nicht den Regeln nach dem Apartment-Modell entspricht, so
	// mssen Sie den nachfolgenden Code ndern, indem Sie den 6. Parameter von
	// afxRegApartmentThreading auf 0 ndern.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_ARIESSTEPVIEW,
			IDB_ARIESSTEPVIEW,
			afxRegApartmentThreading,
			_dwAriesStepViewOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CAriesStepViewCtrl::CAriesStepViewCtrl - Konstruktor

CAriesStepViewCtrl::CAriesStepViewCtrl()
{
	InitializeIIDs(&IID_DAriesStepView, &IID_DAriesStepViewEvents);

#if 0

	CAritStep* s = new CAritStep();

	s->addBits(true,4);
	s->addBits(false,4);
	s->setBottom(0);
	s->setTop(1);
	s->setUpper(0.9);
	s->setLower(0.1);
	s->setSymbol('a');
	addStep(s->toString());


	s = new CAritStep();
	s->addBits(true,8);
	s->addBits(false,2);
	s->setBottom(0.1);
	s->setTop(0.9);
	s->setUpper(0.82);
	s->setLower(0.18);
	s->setSymbol('a');
	addStep(s->toString());

	s = new CAritStep();
	s->addBits(true,8);
	s->addBits(false,2);
	s->setBottom(0.18);
	s->setTop(0.82);
	s->setUpper(0.67);
	s->setLower(0.4);
	s->setSymbol(0);
	addStep(s->toString());

	s->addBits(true,4);
	s->addBits(false,4);
	s->setBottom(0.9994);
	s->setTop(1);
	s->setUpper(0.9998);
	s->setLower(0.1);
	s->setSymbol('a');
	addStep(s->toString());

	s->addBits(true,4);
	s->addBits(false,4);
	s->setBottom(0.998);
	s->setTop(1);
	s->setUpper(1);
	s->setLower(1);
	s->setSymbol('a');
	addStep(s->toString());

#endif
}


/////////////////////////////////////////////////////////////////////////////
// CAriesStepViewCtrl::~CAriesStepViewCtrl - Destruktor

CAriesStepViewCtrl::~CAriesStepViewCtrl()
{
	clearAll();
}


/////////////////////////////////////////////////////////////////////////////
// CAriesStepViewCtrl::OnDraw - Zeichenfunktion

void CAriesStepViewCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{

	int oldMapMode = pdc->GetMapMode();
	//store original bounds 
	CRect rc = rcBounds;
	pdc->LPtoDP(&rc);

	pdc->SetMapMode(MM_LOMETRIC);

	//get new Bounds with metric parameters
	pdc->DPtoLP(&rc);


	pdc->FillRect(rc, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));



	CRect stepRect = rc;
	stepRect.right=stepRect.left+(m_stepWidth*10);

	for(int pos = m_position
		;/*stepRect.IntersectRect(&stepRect, &rc) && */(pos<m_steps.size())
		;pos++, stepRect.OffsetRect(m_stepWidth*10,0)){

		//create normalized bounding rectangle and drawing rectangle
		//for the IntersectRect method
		CRect sr = stepRect;
		sr.NormalizeRect();
		CRect br = rc;
		br.NormalizeRect();

		//exit loop, if the rectangle is not visible
		if(!sr.IntersectRect(&sr,&br))
			break;
		
		drawStep(pdc, stepRect, m_steps[pos]);

	}

	pdc->SetMapMode(oldMapMode);
}


/////////////////////////////////////////////////////////////////////////////
// CAriesStepViewCtrl::DoPropExchange - Untersttzung dauerhafter Eigenschaften

void CAriesStepViewCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

    PX_Short(pPX, _T("Position"), m_position, 0);
    PX_Short(pPX, _T("StepWidth"), m_stepWidth, 45);

}


/////////////////////////////////////////////////////////////////////////////
// CAriesStepViewCtrl::OnResetState - Setzt das Steuerelement in den Standardzustand zurck

void CAriesStepViewCtrl::OnResetState()
{
	COleControl::OnResetState();  // Setzt die Standards zurck, die in DoPropExchange gefunden wurden
	
}


/////////////////////////////////////////////////////////////////////////////
// CAriesStepViewCtrl Behandlungsroutinen fr Nachrichten 


void CAriesStepViewCtrl::clearAll() 
{

	for(CAritStep::StepVectorIterator i = m_steps.begin();i!=m_steps.end();i++)
		delete *i;
	
	m_steps.clear();

	SetModifiedFlag();
	InvalidateControl();


}

short CAriesStepViewCtrl::GetPosition() 
{
	return m_position;
}

void CAriesStepViewCtrl::SetPosition(short nNewValue) 
{
	m_position = nNewValue;
	SetModifiedFlag();
	InvalidateControl();
}


void CAriesStepViewCtrl::drawStep(CDC *pDC, const CRect& rc, CAritStep *step)
{
	
	const int charWidth = 30;
	const int charHeight = 50;
	const int TICKWIDTH = 40;

	CString buffer;

	CPoint top = rc.TopLeft();
	top.x += rc.Width()/2;

	CPoint bottom = top;
	bottom.y = rc.bottom;

	CRect bigC = rc;

	bigC.right -= 3*charWidth;
	bigC.left += 10;
	bigC.top -= charHeight;
	bigC.bottom += 2*charHeight;





	//draw the bigC
	pDC->MoveTo(bigC.TopLeft());
	pDC->LineTo(bigC.right,bigC.top);
	pDC->LineTo(bigC.BottomRight());
	pDC->LineTo(bigC.left,bigC.bottom);

	//the top and bottom bounds
	buffer.Format("%.15f",step->getTop());
	pDC->ExtTextOut(bigC.left, bigC.top+charHeight,
        ETO_CLIPPED, rc, buffer, buffer.GetLength(), NULL);
	buffer.Format("%.15f",step->getBottom());
	pDC->ExtTextOut(bigC.left, bigC.bottom-3,
        ETO_CLIPPED, rc, buffer, buffer.GetLength(), NULL);

	//write the binary string
	buffer = step->getBitString();
	pDC->ExtTextOut(bigC.left, bigC.bottom-charHeight-2,
        ETO_CLIPPED, rc, buffer, buffer.GetLength(), NULL);

	//calculate the step bounds
	int bigCRange = bigC.top - bigC.bottom;
	int upperHeight = bigC.bottom + (step->getRelativeUpper() * bigCRange) ; 
	int lowerHeight = bigC.bottom + (step->getRelativeLower() * bigCRange) ; 


	//draw the symbol scaling ticks
	pDC->MoveTo(bigC.right - (TICKWIDTH/2),upperHeight);
	pDC->LineTo(bigC.right + (TICKWIDTH/2),upperHeight);
	pDC->MoveTo(bigC.right - (TICKWIDTH/2),lowerHeight);
	pDC->LineTo(bigC.right + (TICKWIDTH/2),lowerHeight);

	//draw the symbol name
	int symbol = step->getSymbol();
//	if(IsCharAlphaNumeric(symbol))
	if(symbol>=0x20&&symbol<=0x7f)
		buffer.Format("%d ('%c')", step->getSymbol(),step->getSymbol());
	 else if(symbol == 257)
		 buffer = "EOF";
	 else buffer.Format("%d", symbol,symbol);

	//update coordinates if the arey out of the bigC bounds
	int textY = (upperHeight+lowerHeight)/2 + (charHeight/2);
	if(textY>bigC.top-10)
		textY = bigC.top-10;
	else if(textY<bigC.bottom+10+charHeight)
		textY = bigC.bottom+10+charHeight;
	
	pDC->TextOut(bigC.right-(6*charWidth), textY, buffer, buffer.GetLength());
//	pDC->ExtTextOut(bigC.left, (upperHeight+lowerHeight)/2 + (charHeight/2),
//        ETO_CLIPPED, rc, buffer, buffer.GetLength(), NULL);


	CPen newPen;
	newPen.CreatePen(PS_DOT, 1, RGB(0,0,0));

	CPen* oldPen = pDC->SelectObject(&newPen);

	//draw the upscale lines
	pDC->MoveTo(bigC.right + (TICKWIDTH/2)+10,upperHeight);
	pDC->LineTo(rc.right, bigC.top);
	pDC->MoveTo(bigC.right + (TICKWIDTH/2)+10,lowerHeight);
	pDC->LineTo(rc.right, bigC.bottom);

	pDC->SelectObject(oldPen);




}

short CAriesStepViewCtrl::GetStepWidth() 
{
	// ZU ERLEDIGEN: Fgen Sie hier Ihre Behandlungsroutine fr Eigenschaften hinzu

	return m_stepWidth;;
}

void CAriesStepViewCtrl::SetStepWidth(short nNewValue) 
{
	m_stepWidth = nNewValue;
	SetModifiedFlag();
	InvalidateControl();
}





void CAriesStepViewCtrl::addStep(LPCTSTR data) 
{
	
	CAritStep* newElement = new CAritStep(data);
	assert(newElement);
	m_steps.push_back(newElement);
	SetModifiedFlag();
	InvalidateControl();
}


short CAriesStepViewCtrl::GetStepNum() 
{
	return m_steps.size();
}

void CAriesStepViewCtrl::SetStepNum(short nNewValue) 
{
	// ZU ERLEDIGEN: Fgen Sie hier Ihre Behandlungsroutine fr Eigenschaften hinzu

	SetModifiedFlag();
}
