#if !defined(AFX_ARIESSTEPVIEWCTL_H__FF70D8FB_1D86_11D3_9CA3_D2D3C4000000__INCLUDED_)
#define AFX_ARIESSTEPVIEWCTL_H__FF70D8FB_1D86_11D3_9CA3_D2D3C4000000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// AriesStepViewCtl.h: Deklaration der CAriesStepViewCtrl-ActiveX-Steuerelementeklasse.

/////////////////////////////////////////////////////////////////////////////
// CAriesStepViewCtrl: Siehe AriesStepViewCtl.cpp fr Implementierung.

#include <vector>
#include "AritStep.h"
using namespace std ; //for the list

class CAriesStepViewCtrl : public COleControl
{
	DECLARE_DYNCREATE(CAriesStepViewCtrl)

// Konstruktor
public:
	CAriesStepViewCtrl();

// berladungen
	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAriesStepViewCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	//}}AFX_VIRTUAL

private:
	void drawStep(CDC* pdc, const CRect& rcBounds, CAritStep* step);
	CAritStep::StepVector m_steps;
//	vector<CAritStep*> m_steps;
//	typedef vector<CAritStep*>::iterator StepIterator;
	short m_position;
	short m_stepWidth;
// Implementierung
protected:
	~CAriesStepViewCtrl();

	DECLARE_OLECREATE_EX(CAriesStepViewCtrl)    // Klassenerzeugung und GUID
	DECLARE_OLETYPELIB(CAriesStepViewCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CAriesStepViewCtrl)     // Eigenschaftenseiten-IDs
	DECLARE_OLECTLTYPE(CAriesStepViewCtrl)		// Typname und versch. Status

// Nachrichtenzuordnungstabellen
	//{{AFX_MSG(CAriesStepViewCtrl)
		// HINWEIS - Der Klassen-Assistent fgt Member-Funktionen hier ein und entfernt diese.
		//    Innerhalb dieser generierten Quelltextabschnitte NICHTS VERNDERN!
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch-Tabellen
	//{{AFX_DISPATCH(CAriesStepViewCtrl)
	afx_msg short GetPosition();
	afx_msg void SetPosition(short nNewValue);
	afx_msg short GetStepWidth();
	afx_msg void SetStepWidth(short nNewValue);
	afx_msg short GetStepNum();
	afx_msg void SetStepNum(short nNewValue);
	afx_msg void clearAll();
	afx_msg void addStep(LPCTSTR data);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

// Ereignistabellen
	//{{AFX_EVENT(CAriesStepViewCtrl)
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch- und Ereignis-IDs
public:
	enum {
	//{{AFX_DISP_ID(CAriesStepViewCtrl)
	dispidPosition = 1L,
	dispidStepWidth = 2L,
	dispidStepNum = 3L,
	dispidClearAll = 4L,
	dispidAddStep = 5L,
	//}}AFX_DISP_ID
	};
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_ARIESSTEPVIEWCTL_H__FF70D8FB_1D86_11D3_9CA3_D2D3C4000000__INCLUDED)
