// MathEncodeObserver.h: Schnittstelle fr die Klasse CMathEncodeObserver.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MATHENCODEOBSERVER_H__A6BC3B6A_1991_11D3_9C9B_AAEB20000000__INCLUDED_)
#define AFX_MATHENCODEOBSERVER_H__A6BC3B6A_1991_11D3_9C9B_AAEB20000000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "EncodeObserver.h"
	struct MathData{
		int symbolCount;
		int zeroCount;
		double entropie;
		double redundanz;
		double specialSymbolCount[258];
		double specialSymbolProbability[258];
		double specialSymbolInformation[258];
		double specialSymbolEntropie[258];
	};

class CMathEncodeObserver : public CEncodeObserver  
{
public:
	virtual void observeDestination(int symbol);
	virtual void observeSource(int symbol);
	CMathEncodeObserver();
	virtual ~CMathEncodeObserver();
	MathData m_srcData, m_dstData;

private:
	void countSymbol(int symbol, MathData& data);



};

#endif // !defined(AFX_MATHENCODEOBSERVER_H__A6BC3B6A_1991_11D3_9C9B_AAEB20000000__INCLUDED_)
