// PatternEncodeSource.cpp: Implementierung der Klasse CPatternEncodeSource.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "stdafx.h"
#include "PatternEncodeSource.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CPatternEncodeSource::CPatternEncodeSource()
{

}

CPatternEncodeSource::~CPatternEncodeSource()
{

}

int CPatternEncodeSource::getNextByte()
{
	
	int pos = m_symbolsAlreadyRead%m_patternToProduce.GetLength();
	m_symbolsAlreadyRead++;
	unsigned char ret = m_patternToProduce[pos];

	return ret;

}


bool CPatternEncodeSource::hasMoreBytes()
{
	return m_symbolsAlreadyRead<m_symbolsToRead;
}

bool CPatternEncodeSource::open()
{
	return true;
}

bool CPatternEncodeSource::close()
{
	return true;
}


void CPatternEncodeSource::setPattern(CString pattern, int count)
{
	m_symbolsAlreadyRead = 0;
	m_symbolsToRead = count*pattern.GetLength();
	m_patternToProduce = pattern;

}
