// ZerosEncodeSource.h: Schnittstelle fr die Klasse CZerosEncodeSource.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ZEROSENCODESOURCE_H__0AF45D17_1786_11D3_9C95_A64108000000__INCLUDED_)
#define AFX_ZEROSENCODESOURCE_H__0AF45D17_1786_11D3_9C95_A64108000000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "EncodeSource.h"

class CZerosEncodeSource : public CEncodeSource  
{


private:
	int m_bytesAlreadyRead;
	int m_bytesToProduce;

//getter and setter methods
public:
	virtual void setBytesToProduce(int b){m_bytesToProduce=b;}
	virtual int getBytesToProduce(){return m_bytesToProduce;}


public:
	virtual bool close();
	virtual bool open();
	virtual bool hasMoreBytes();
	virtual int getNextByte();
	CZerosEncodeSource();
	virtual ~CZerosEncodeSource();

};

#endif // !defined(AFX_ZEROSENCODESOURCE_H__0AF45D17_1786_11D3_9C95_A64108000000__INCLUDED_)
