// FileEncodeSource.cpp: Implementierung der Klasse CFileEncodeSource.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "stdafx.h"
#include "FileEncodeSource.h"
#include <assert.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CFileEncodeSource::CFileEncodeSource()
{
	setFilename("");
}

CFileEncodeSource::~CFileEncodeSource()
{

}

int CFileEncodeSource::getNextByte()
{
	return fgetc(m_srcFile);
}

bool CFileEncodeSource::hasMoreBytes()
{
	return feof(m_srcFile)?false:true;
}

bool CFileEncodeSource::open()
{
	assert(getFilename()!="");

	m_srcFile = fopen(getFilename(), "rb");
	if(m_srcFile==NULL){
		return false;
	}
	return true;
}

bool CFileEncodeSource::close()
{
	return fclose(m_srcFile)?false:true;
}
