// PatternEncodeSource.h: Schnittstelle fr die Klasse CPatternEncodeSource.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PATTERNENCODESOURCE_H__B62745E1_27B4_11D3_B532_00400548E614__INCLUDED_)
#define AFX_PATTERNENCODESOURCE_H__B62745E1_27B4_11D3_B532_00400548E614__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "EncodeSource.h"

class CPatternEncodeSource : public CEncodeSource  
{

private:
	CString m_patternToProduce;
	int m_symbolsAlreadyRead;
	int m_symbolsToRead;

//getter and setter methods
public:

public:
	virtual void setPattern(CString pattern, int count);
	virtual bool close();
	virtual bool open();
	virtual bool hasMoreBytes();
	virtual int getNextByte();
	CPatternEncodeSource();
	virtual ~CPatternEncodeSource();

};

#endif // !defined(AFX_PATTERNENCODESOURCE_H__B62745E1_27B4_11D3_B532_00400548E614__INCLUDED_)

